/* n2i V1.03 16-Sep-98 */
/* NMEA to IPS format converter */
/* mailto:gigo@yk.rim.or.jp */
/* http://www1.yk.rim.or.jp/~gigo/ */

#define AKI_H8_MOTHER 0

#if AKI_H8_MOTHER == 1
#define VERSION " V1.03M"
#else
#define VERSION " V1.03"
#endif

#define SERIALNO "S/N 000-00"
#define SIGNON "\015\012n2iH8 NMEA->IPS"VERSION"\015\012"SERIALNO"\015\012\015\012"
#define SIGNONLCD "\001\010\014\001\002n2iH8"VERSION"\300"SERIALNO

/* options.BIT.IRPHY is default ON. */
/*#define SWMASK 0xfd*/
/* options.BIT.SMAT is default ON. */
#define SWMASK 0xf7

/* history */
/* 13-Sep-98 V1.03 */
/*	 Support IR Remote */
/* 17-Apr-98 V1.02 */
/*	 Support AKI H8 mother board (LED,DipSW,LCD) */
/* 16-Mar-98 V1.00a */
/*	 Fix initialize related probrems */
/* 10-Mar-98 V1.00 first release */
/*	 Escape direct mode by IrDA input */
/* 08-Mar-98 V0.24 final beta */
/*	 support IrDA Rx */
/*	 refine LCD support */
/* 27-Feb-98 V0.23 */
/*	 LCD support */
/* 25-Feb-98 V0.22 */
/*	 IrDA Tx bug fix, adjust timing */
/* 13-Feb-98 V0.21 */
/*	 support IrDA TX */
/*	 support LCD(experimental) */
/*	 print switch status on signon. */
/* 12-Feb-98 V0.20 */
/*	 prevent low-voltage and poor reset problem */
/*	   rewrite initialize routine */
/*	   default speed 8MHz -> can 3.3V operation */
/*	 add dip switch mask */
/*	 add thermal sensor support */
/*	 auto baud rate switching  */
/*	 auto detect sensor equipment to ADC. change ADC to ADCOFF
/* 10-Feb-98 V0.19 */
/*	 minor bug FIX (@DMD on %RM) */
/* 09-Feb-98 V0.18 */
/*	 optimize */
/* 08-Feb-98 V0.17 */
/*	 support NMEA checksum ignore option */
/* 05-Feb-98 V0.16 */
/*	 more refine for clock down mode */
/*	 WGS84 and Tokyo auto recognition(GARMIN) */
/*	 extract private sentence $Px x:GPSTYPE */
/* 04-Feb-98 V0.15 */
/*	 refine for speed and accuracy */
/*	 support NMEA checksum */
/* 03-Feb-98 V0.14 */
/*	 support Jupiter GPS unit */
/* 02-Feb-98 V0.13 */
/*	 remove dynamic clock down code. */
/*	 add %CK for clock down and restart */
/* 31-Jan-98 V0.12 */
/*	 add NMEA 9600 mode */
/*	 read P2 for initial option */
/*	 add echo mode %EC0,%EC1 */
/*	 refine DM.D ->DM.S routine robustness */
/*	 support ADC for pressure gage */
/*	 add %AD {0|1} for switch ALT from NMEA | gage */
/* 28-Jan-98 V0.11 */
/*	 set default to IPS5000 format */
/*	 add @KT 8ch,@KE 12ch support */
/*	 add @DMS,@DMD support */
/*	 add @SKx support */
/*	 add %SO SignOn command */
/* 21-Jan-98 V0.10 */
/*	 source code refined. :-) */
/*	 standby extraneous hardware for save power. */
/*	 bit to bit THROUGH mode. */
/*	 use old data if exist. */
/*	 use all position data. */
/*	 cmd %MN monitor */
/*		 %08/%12  8ch/12ch */
/*		 %AL/%RM use all data/GPRMC only */
/*		 %DI direct mode */
/* 18-Jan-98 V0.09 */
/*	 first beta release */

/* Wish list */
/*	GARMIN protocol to IPS (Try it now ?) */
/*	Rockwell binary command support for set altitude(Jupiter) */
/*	IPS to NMEA (needs???) */
/*	Datum conversion */
/*	Datum setting(TripMate) */
/*	Tempreture adjustment */
/*	IR remote controller support */
/*	DTMF remote controller */
/*	IRIG-B support(Jupiter) */

/* Check list */
/*	round up */

/* for AKI-H8/3048F Single Board Microcomputer */
/**/
#define H8
/**/

/*/
#define DTMF 1
/*/

#ifdef H8
/* default SWMASK */
#ifndef SWMASK
#define SWMASK 0xff
#endif
/* default LCD contrast */
#ifndef LCD_CONT
#define LCD_CONT 24
#endif

/* if defined, read from SCI1, put to SCI1. push ']' to monitor.*/
/* H8 Mode only */
/*/
#define ECHO_DEBUG
/*/
/*/
#define WINDBG
/*/
#ifdef WINDBG
#define SWINIT 0xBF
#endif

#if AKI_H8_MOTHER == 1
/* Port usage P1:None, P2:DipSW, P3:LCD data/cint, P4:Push SW, P5:LED, */
/*	 P6:None, P7:ADC , P8:None,, P9:SCI, PA:ITU, PB:ITU */
#define LCDIF 4						/* 4 bit I/F */
#define LCD_RS_SIG	P3.DR.BIT.B4	/* LCD RS SIGNAL */
#define LCD_RW_SIG	P3.DR.BIT.B6	/* NC - LCD R/W SIGNAL */
#define LCD_E_SIG	P3.DR.BIT.B5	/* LCD E SIGNAL */
#define LCD_DDR_OUT P3.DDR = 0x3f	/* set data port to output */
#define LCD_DDR_IN	P3.DDR = 0x30	/* set data port to input */
#define LCD_PORT	P3.DR.BYTE		/* write data to LCDII */
#define LCD_DDR_CNT P3.DDR = 0x30	/* LCD control port to output */
#define LCDTYP		(2-P4.DR.BIT.B4)/* LCD type check bit = S1 */
#define LCD_HGH_INP ((P3.DR.BYTE&0xf) == 0x0f)	/* LCD high impedance check */
#define LEDENB		P5.DDR = 3
#define LCDBLENB	P5.DDR = 7
#define LEDON		P5.DR.BIT.B0 = 1
#define LEDOFF		P5.DR.BIT.B0 = 0
#define LCDBL_BIT	P5.DR.BIT.B2
#else
/* Port usage P1:None, P2:DipSW, P3:LCD data, P4:LCD cont, P5:None, */
/*	 P6:None, P7:ADC , P8:None,, P9:SCI, PA:ITU, PB:LED&ITU */
/*	dip switch needs pull-up 2,4,5 */
/*	2 is selected as other port divided CN1 & CN3. */
/*	LED drive 1,2,5,B.*/
/*	B is selected as 5V allocated CN1.*/
/*	LCD DataPort is P3. ControlPort is P4 as CN3 pin assign. */
#define LCDIF 8						/* 8 bit I/F */
#define LCD_TYP_BIT	P4.DR.BIT.B4
#define LCD_RS_SIG	P4.DR.BIT.B5	/* LCD RS SIGNAL */
#define LCD_RW_SIG	P4.DR.BIT.B6	/* LCD R/W SIGNAL */
#define LCD_E_SIG	P4.DR.BIT.B7	/* LCD R/W SIGNAL */
#define LCD_DDR_OUT P3.DDR = 0xff;	/* set data port to output */
#define LCD_DDR_IN	P3.DDR = 0x0;	/* set data port to input */
#define LCD_PORT	P3.DR.BYTE		/* write data to LCDII */
#define LCD_DDR_CNT P4.DDR = 0xE0	/* LCD control port to out put */
#define LCDTYP		(P4.DR.BIT.B4+1)	/* LCD type check bit */
#define LCD_HGH_INP (P3.DR.BYTE == 0xff)	/* LCD high impedance check */
#define LEDENB		PB.DDR = 1
#define LCDBLENB	PB.DDR = 3
#define LEDON		PB.DR.BIT.B0 = 0
#define LEDOFF		PB.DR.BIT.B0 = 1
#define LCDBL_BIT	PB.DR.BIT.B1
#endif

/* watch dog timer */
#define WDG_W_TCSR_TCNT (*(volatile unsigned int *)0xFFFFA8) /* TCSR & TCNT	Address for write*/
#define WDG_W_RSTCSR	(*(volatile unsigned int *)0xFFFFAA) /* RSTCSR	Address for write*/

#define WDG_R_TCSR		(*(volatile unsigned char *)0xFFFFA8) /* TCSR Address for read */
#define WDG_R_TCNT		(*(volatile unsigned char *)0xFFFFA9) /* TCNT Address for read */
#define WDG_R_RSTCSR	(*(volatile unsigned char *)0xFFFFAB) /* RSTCSR	 Address for read */

#ifndef WINDBG
#include <3048f.h>

extern void sleep(void);	/* sleep */
extern void monitor(void);	/* jump H8 monitor */

#pragma interrupt RxInt1
#pragma interrupt RxInt0
#pragma interrupt TxInt0
#pragma interrupt TxInt1
#pragma interrupt ADCInt
#pragma interrupt IrTxEndInt
#pragma interrupt IrRxPeriodInt
#pragma interrupt IrRCRxInt

#else /* for VCPP DEBUG for H8 Mode */
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "3048f.h"

#define monitor();	/* jump H8/300H monitor */
extern void sleep(void);	/* sleep */

void  RxInt0(void);
void  RxInt1(void);
void  TxInt0(void);
void  TxInt1(void);
void  ADCInt(void);
void IrTxEndInt(void);
void IrRxPeriodInt(void);
void IrRCRxInt(void);


#undef SCI0
#undef SCI1
struct st_sci SCI0,SCI1;
#undef DIVCR
union  un_divcr DIVCR;
#undef MSTCR
union un_mstcr MSTCR;
#undef AD
struct st_ad AD;
#undef DA
struct st_da DA;
#undef P2
struct st_p2 P2;
#undef P3
struct st_p1 P3;
#undef P4
struct st_p4 P4;
#undef P5
struct st_p5 P5;
#undef P9
struct st_p9 P9;
#undef PB
struct st_p1 PB;
#undef ITU
struct st_itu ITU;
#undef ITU0
struct st_itu0 ITU0;
#undef ITU1
struct st_itu0 ITU1;
#undef ITU2
struct st_itu2 ITU2;
#undef ITU3
struct st_itu0 ITU3;
#undef DMAC0A
struct st_sam DMAC0A;
#undef DMAC0B
struct st_sam DMAC0B;
#undef DMAC1A
struct st_sam DMAC1A;
#undef DMAC1B
struct st_sam DMAC1B;
#undef DMAC0
struct st_fam DMAC0;
#undef DMAC1
struct st_fam DMAC1;
#undef RFSHC
struct st_rfshc RFSHC;
#undef WDG_R_RSTCSR
int WDG_R_RSTCSR;
#endif

#else
/* for FILTER */
#define FILTER
#include <stdio.h>
#include <stdlib.h>
#endif

#include <string.h>
#include "ips.h"
#ifdef DTMF
#include "dtmf.h"
#else
void DTMFTxEndInt(void)
{}
#endif

#ifdef ECHO_DEBUG
/* SCI0 replace SCI1, All baud 9600 */
#undef SCI0
#define SCI0	(*(volatile struct st_sci	*)0xFFFFB8) /* SCI1	 Address*/
#define BAUD_16MH_4800	((unsigned char) 51)
#define BAUD_16MH_9600	((unsigned char) 51)
#define BAUD_16MH_19200 ((unsigned char) 51)
#else
#define BAUD_16MH_4800	((unsigned char)103)
#define BAUD_16MH_9600	((unsigned char) 51)
#define BAUD_16MH_19200 ((unsigned char) 25)
#endif

/* status code */
#define BSY_MASK 0x70
#define ST_BSY2 0x40	/* LCD */
#define ST_BSY1 0x20	/* IrTx0 */
#define ST_BSY0 0x10	/* Tx1 */
#define ST_OTH	0x04
#define ST_EOL	0x03
#define ST_FIL	0x02
#define ST_INI	0x01
#define ST_IDL	0x00
#define ST_OVF	0x80
#define ST_CER	0x81

/* hash code */
#define C_GPGSV 0x55
#define C_GPGGA 0x56
#define C_GPRMC 0x4b
#define C_GPGSA 0x42
#define C_PGRMM 0x45
#define C_GPGLL 0x50

/* error code */
#define ERR_RX0 0x01
#define ERR_SUM 0x02
#define ERR_TX0 0x04
#define ERR_RX1 0x10
#define ERR_TX1 0x40

/* data code */
#define D_DATE	0x80	/* DATE */
#define D_TIME	0x40	/* TIME */
#define D_POS	0x20	/* LAT,LON */
#define D_ANG	0x10	/* ANGLE(COURSE) */

#define D_SPD	0x08	/* SPEED */
#define D_ALT	0x04	/* ALITUDE */
#define D_SATS	0x02	/* SATELLITE STATUS */
#define D_SATP	0x01	/* SATELLITE POSITION */

#define GP_GGA (D_ALT)
#define GP_RMC (D_SPD|D_ANG)
#define GP_GSA (D_SATS)
#define GP_GSV (D_SATP)

#define GP_ALL (D_DATE|D_TIME|D_POS|D_SPD|D_ANG|D_ALT|D_SATS|D_SATP)

#define ADINVALID 0xffff

/* some instructions for 44780 LCD control */
#if LCDIF == 4
#define FUNCTION_SET_40	0x23
#define FUNCTION_SET_41	0x22
#define FUNCTION_SET_42	0x28	/* 4 bit interface, 5x7 dots, 2 lines */
#define reset_lcd()		reset_lcd4()
#define write_lcd(d,s)	write_lcd4(d,s)
#define rd_lcd(s)		rd_lcd4(s)
#else
#define FUNCTION_SET_8	0x38	/* 8 bit interface, 5x7 dots, 2 lines */
#define reset_lcd()		reset_lcd8()
#define write_lcd(d,s)	write_lcd8(d,s)
#define rd_lcd(s)		rd_lcd8(s)
#endif

#define RETURN_HOME		'\200'	/* to first position on the display */
#define NEXT_LINE		'\300'
#define THIRD_LINE		'\224'
#define FOURTH_LINE		'\324'

#define LCD_INST		0x0
#define LCD_DATA		0x1

#define WAIT	1	/* wait timer end */
#define NOWAIT	0	/* set timer and return */

/* variables */
unsigned char data;				/* gained data */
unsigned char max_sat;			/* maximum satellite */
unsigned char now_sat;			/* processed satellite */
char *sump;						/* pointer for NMEA sentence check sum */
char csum;						/* calculated check sum */
char styp;						/* sentence type hash code */
unsigned char gpstype;			/* GPS Type */
char datebuf[IPS_UTC_DATE_LEN]; /* last filled date */

typedef union {					/* OPT */
	unsigned char BYTE;			/*	Byte Access */
	struct {					/*	Bit	 Access */
		unsigned char SPEED:1;	/* 0:4800,1:9600 - NMEA BPS */
		unsigned char ADCOFF:1; /* 0:AUTO,1:OFF - use ADC for Alitude */
		unsigned char ECHO:1;	/* 0:OFF,1:ON - ECHO */
		unsigned char RMC:1;	/* 0:ALL,1:RMC - use RMC location only */
		unsigned char SMAT:1;	/* 0:IPS,1:SMAT - output format */
		unsigned char CERR:1;	/* 0:Check,1:ignore - NMEA Check sum */
		unsigned char IRPHY:1;	/* 0:Disable,1:Enable - IrPHY out */
		unsigned char DMD:1;	/* 0:DMS,1:DMD - LAT,LON format */
	} BIT;
} opt_t ;

opt_t options;

unsigned char sw;		/* setting sw value holder */

unsigned char gear;		/* clock divisor for gear function */

unsigned ad0value;		/* ADC0 value */
unsigned ad1value;		/* ADC1 value */

unsigned char error;	/* error holder */
unsigned char rerror;	/* receive error count */

/* NMEA sentence */
#define MAXPARAM 20
char *param[MAXPARAM+1];	/* parameter pointer for NMEA sentence */

/* IPS string */
unsigned char ips;		/* ipsbuf status */
#define MAXIBUF 131		/* IPS buffer length */
char ipsbuf[MAXIBUF];	/* IPS string holder */

/* Rx0 NMEA input, alternate buffer */
unsigned char capt;		/* Rx0 data capture mode */
#define MAXLBUF 82		/* nmea buffer length (input) */
char lbuf0[MAXLBUF];	/* Rx0 input buffer 0 */
char lbuf1[MAXLBUF];	/* Rx0 input buffer 1 */
char *lbufp;			/* Rx0 input pointer */
char *lbufip;			/* Rx0 input buffer pointer */
char *lbufpp;			/* Rx0 process buffer pointer */

/* Tx0 NMEA echo, ring buffer */
#define MAXTX0BUF 32
char tx0buf[MAXTX0BUF];
char *tx0tp;			/* Tx0 transmit data pointer */
char *tx0fp;			/* fill pointer */

/* Rx1 command input, dual buffer */
#define MAXCBUF 32
unsigned char cmd;		/* cmdbuf status */
char cmdbuf[MAXCBUF];	/* buffer for Rx1 */
char cbuf[MAXCBUF];		/* buffer for command process */
char *cmdp;				/* command buffer pointer */

/* Tx0 IPS string output buffer */
char *txp;
char txbuf[MAXIBUF];

/* IrTx byte edge holder */
unsigned edgebuf0[20];
/*
unsigned edgebuf1[20];
unsigned *nextbuf;
unsigned nextcnt;
*/

/* IrTx IPS string output buffer */
char *irtxp;
char irbuf[MAXIBUF];

/* IrRx byte edge buffer */
unsigned *captbufp;		/* pointer for receiveing buffer */
unsigned *captured;		/* pointer for received buffer */
unsigned captbuf0[12], captbuf1[12];	/* edge capture buffer */
int IrRxStat;			/* IrRx receive status */

/* IrRx command input buffer  */
char Ircmdbuf[MAXCBUF];	/* buffer for Ir command process */
char *Ircmdp;			/* Ir command buffer pointer */

/* LCD */
char LCDEquiped;
char *lcdtxp;
char lcdbuf[85];	/* (20+1)*4 + 1 */

/* IR Remote */
long RCVal;
unsigned char RCBit,RCCode;
char RCstr[9];

/* function proto type */
void main(void);
void initSCI(volatile struct st_sci *sci,unsigned char baud);
void WaitTxEmpty(void);
void bit2bit(void);
void signon(void);
unsigned char  getRx0Buf(void);
void initTx0buf(void);
unsigned char  putTx0Buf(char  c);
void kickAD(void);
unsigned char  getsentence(unsigned char c);
unsigned char  getcmd(unsigned char c);
unsigned char  getIrcmd(void);
unsigned char  parse(char *p);
void switched(unsigned char sw);
void initg2i(void);
unsigned char  buildips(char *cp);
void gpgll(void);
void gpgga(void);
void gprmc(void);
void gpgsa(void);
void gpgsv(unsigned char pcnt);
void pgrmm(void);

void fillALT(int  v);
unsigned char sep(char	*p);
int	 timchk(int	 n);
void strFcpy(char	*dist,char	*source,unsigned char  n);
int	 atoi(const char  *p);
char calwday(unsigned year,unsigned mon,unsigned day);

void initIrPHY(void);
void startIrRx0(void);
void kickIrTx0(void);
int	makIrPat(char c,unsigned buf[]);
int	decodeIr(void);

void reset_lcd4(void);
void reset_lcd8(void);
unsigned char rd_lcd4(unsigned char select);
unsigned char rd_lcd8(unsigned char select);
void write_lcd4(unsigned char data, unsigned char select);
void write_lcd8(unsigned char data, unsigned char select);
void lcdcontrast(char c);
void put_lcd(const char *p);
void maklcddata(void);

void clk_wait(long t,unsigned char wait);
void reset(void);

void initIrRCRx(void);
char *RCCode2str(void);

#define EVER ;;

#ifdef FILTER
void main(void)
{
	int c;

	options.BYTE = 0;
	options.BIT.SPEED = options.BIT.ECHO = options.BIT.ADC = 0;
	initg2i();

	while((c=getchar())!=EOF)
		if (getsentence((char)c) == ST_EOL)
			if (buildips(lbufpp) & ST_BSY0)
				puts(ipsbuf);
	exit(0);
}
#endif /* end FILTER */

#ifdef H8
/* Start of H8 specific code */
#ifdef WINDBG
/* for emulation DEBUG for VCPP */
void sleep(void)
{
	int c;

	if (SCI1.SCR.BIT.TIE) {
		SCI1.SSR.BIT.TDRE = 1;
		TxInt1();
	}
	if (SCI0.SCR.BIT.TIE) {
		SCI0.SSR.BIT.TDRE = 1;
		TxInt0();
		putc(SCI0.TDR,stderr);
	}
	if ((c=getchar())== EOF) {
		while(SCI1.SCR.BIT.TIE) {
			SCI1.SSR.BIT.TDRE = 1;
			TxInt1();
		}
		exit(0);
	} else {
		SCI0.SSR.BYTE = 0x40;
		SCI0.RDR = (unsigned char)c;
		RxInt0();
	}
	if ((AD.CSR.BIT.ADIE == 1)&&(MSTCR.BIT.MSTOP0 == 0)){	/* Enable AD Int */
		AD.DRA = rand() & ~0x3F;
		ADCInt();
	}
	if (ITU0.TIER.BIT.IMIEA) {
		for (;DMAC0A.ETCR;DMAC0A.ETCR--) {
			ITU0.GRA = *((unsigned *)DMAC0A.MAR);
			DMAC0A.MAR = (void *)((unsigned)DMAC0A.MAR + sizeof(unsigned));
		}
		DMAC0.MARB = captbufp;
		IrTxEndInt();
	}
	if (ITU1.TIER.BIT.IMIEA) {
#if 0
		aptbufp = captbuf0;
		DMAC0.ETCRB = 10-makIrPat('A',captbufp);
		DMAC0.MARB = captbufp+10-DMAC0.ETCRB;
#endif
		IrRxPeriodInt();
	}
#ifdef DTMF
	if (ITU3.TIER.BIT.IMIEA) { /* DTMF Tx */
		DMAC1A.MAR = (void *) &mute[110];
		DTMFTxEndInt();
	}
#endif
}
/* end of win debug routines */
#endif

void main(void)
{
	unsigned char swcnt,swnew;

#ifdef WINDBG
	P2.DR.BYTE = SWINIT ;
#endif
	/* SET STBY for power save */
	/* FCLK,RES,ITU,(SCI0),(SCI1),DMAC,REF,A/D */
	MSTCR.BYTE = 0xE7;

	P2.DDR = 0;			/* All input */
	P2.PCR.BYTE = 0xff; /* all pull up */

#if AKI_H8_MOTHER == 1
	P4.DDR = 0;			/* All input */
	P4.PCR.BYTE = 0xff; /* all pull up */
#endif

	LCD_DDR_CNT;		/* set LCD control port to output */

	LEDENB;				/* output bit */
	LEDON;				/* LED on for initial OK */

	data = 0;

	txp = txbuf;
	cmdp = cmdbuf;
	Ircmdp = Ircmdbuf;
	lcdtxp = lcdbuf;
	lbufip = lbuf0;
	txbuf[0] = cbuf[0] = cmdbuf[0] = Ircmdbuf[0] = lcdbuf[0] = lbuf0[0] = lbuf1[0] ='\0';
	ips = cmd = ST_IDL;
	captured = NULL;
	lbufpp = NULL;
	IrRxStat = capt = now_sat = swcnt = rerror = 0;

	if ((WDG_R_RSTCSR & 0x80) == 0) {	/* cold start */
		gear = 1;				/* 1/2 clock = half speed */
		memset(datebuf,' ',IPS_UTC_DATE_LEN);
		strcpy(ipsbuf,"      9802113000000n3535091E13844158+07810831039802113000000Q3B");
		gpstype = '?';			/* unknown GPS */
		ad0value = ADINVALID;	/* INVALID value */

		sw = P2.DR.BYTE ;	/* read dip SW */
		options.BYTE = (unsigned char)(sw ^ SWMASK);

		initg2i();

		/* check LCD equipped */
		reset_lcd();
	}
	DIVCR.BIT.DIV = gear;	/* set clock divisor */

	if (options.BIT.ADCOFF==0)
		kickAD();
	if (options.BIT.IRPHY)
		initIrPHY();

	initTx0buf();			/* init ECHO buffer */

	initSCI(&SCI0,(unsigned char)((options.BIT.SPEED)? BAUD_16MH_9600:BAUD_16MH_4800));
	initSCI(&SCI1,BAUD_16MH_9600);

	RCCode = 0xff;
	initIrRCRx();
#ifdef DTMF
	dtmftxp = dtmfbuf;
	*dtmftxp = '\0';
	initDTMF();
#endif

#ifdef WINDBG
	signon();


	maklcddata();
	TxInt1();
	RxInt1();
	TxInt0();
	RxInt0();
#ifdef DTMF
	strcpy(dtmfbuf,"0123456789ABCD*#");
	dtmftxp = dtmfbuf;
	kickDTMF();
#endif
#endif
	for(EVER) {
		sleep();						/* Enable interrupt & sleep */
		if (lbufpp != NULL){			/* get one line ? */
			if (options.BIT.CERR
				|| (csum == (( *sump	- (( *sump	 >'9')? 'A'-10:'0'))<<4)
				+ (*(sump+1) - ((*(sump+1)>'9')? 'A'-10:'0')) ) ){
				LEDOFF;		/* LED off for EOL */
				ips = buildips(lbufpp); /* build IPS string */
			}
			lbufpp = NULL;
		}
		if (ips & ST_BSY0) {			/* data to put SCI exist ? */
			if (SCI1.SCR.BIT.TIE == 0){ /* TxInt Disabled ? (txbuf is idle ?) */
				strcpy(txbuf,ipsbuf);	/* snap shot copy to txbuf */
				ips &= ~ST_BSY0;		/* ips buffer idle */
				txp = txbuf;			/* set txbuf pointer */
				SCI1.SCR.BIT.TIE = 1;	/* TxInt Enable */
				if ((options.BIT.ADCOFF==0) && (MSTCR.BIT.MSTOP0 == 1)) /* use AD Converter */
					kickAD();
			}
		}
		if (RCCode != 0xff) {			/* data to put SCI exist ? */
			if (SCI1.SCR.BIT.TIE == 0){ /* TxInt Disabled ? (txbuf is idle ?) */
				strcpy(txbuf,RCCode2str());	/* snap shot copy to txbuf */
				txp = txbuf;			/* set txbuf pointer */
				SCI1.SCR.BIT.TIE = 1;	/* TxInt Enable */
			}
		}
		if (ips & ST_BSY1) {			/* data to put IrPHY exist ? */
			if (ITU0.TIER.BIT.IMIEA == 0) {		/* IrTx Idle ? */
				if (ITU1.TIER.BIT.IMIEB == 0) {	/* IrRx Idle ? */
					ITU1.TIER.BIT.IMIEA = 0;	/* stop IrRx */
					if (ITU1.TIER.BIT.IMIEB == 0) {	/* stop IrRx sure ? */
						strcpy(irbuf,ipsbuf);	/* snap shot copy to irbuf */
						ips &= ~ST_BSY1;		/* ips buffer idle */
						irtxp = irbuf;			/* set irbuf pointer */
						kickIrTx0();			/* kick start IrTx0 */
#ifdef WINDBG
						options.BIT.IRPHY = 0;	/* one line only for debug */
#endif
					} else {
						ITU1.TIER.BIT.IMIEA = 1;/* stop Rx Failed */
					}
				}
			}
		}
		if (ips & ST_BSY2) {			/* data to put LCD exist ? */
			if (*lcdtxp == '\0') {		/* lcdbuf is idle ? */
				maklcddata();			/* prepare LCD data */
				lcdtxp = lcdbuf;		/* set lcdbuf pointer */
				ips &= ~ST_BSY2;		/* ips buffer idle */
			}
		}
		if (LCDEquiped && *lcdtxp) {
			if ((rd_lcd(LCD_INST) & 0x80) == 0)	/* LCD ready ? */
				if ((*lcdtxp < ' ') && (*lcdtxp != '\337'))
					write_lcd(*lcdtxp++,LCD_INST);
				else
					write_lcd(*lcdtxp++,LCD_DATA);
		}
		if (captured!=NULL)				/* something received */
			if (getIrcmd() == ST_EOL)
				(void) parse(Ircmdbuf);	/* parse command */
		if (cmd == ST_EOL){				/* get one line ? */
			strcpy(cbuf,cmdbuf);		/* copy buffer */
			cmd = ST_IDL;				/* command buffer idle */
			(void) parse(cbuf);			/* parse command */
		}
		if (sw != (swnew = P2.DR.BYTE)) {	/* sw changed ? */
			if (swcnt++ >15) {			/* stabilized ? */
				switched((unsigned char)(swnew ^ sw));
				sw = swnew;
				swcnt = 0;
			}
		} else {
			swcnt = 0;
		}
		if (rerror > 10) {				/* burst error occurred ? */
			opt_t val;
			val.BYTE = 0;val.BIT.SPEED = 1;
			switched(val.BYTE);			/* switch another speed */
			rerror = 0;
		}
	}
}

/* initialize serial communication interface */
void initSCI(volatile struct st_sci *sci, unsigned char baud)
{
	register unsigned  i;

	sci->SCR.BYTE = 0;	/* TIE=RIE=TE=RE=MPIE=TEIE=CKE1=CKE0=0 */
	sci->SMR.BYTE = 0;
	sci->BRR = (unsigned char)(baud >> DIVCR.BIT.DIV);
	clk_wait((baud+2)*32,WAIT);	/* wait 1 bit */
	sci->SCR.BYTE = 0x30;	/* TE=1,RE=1 */
	i = sci->SSR.BYTE;
	sci->SSR.BYTE = 0x80;
	sci->SCR.BIT.RIE = 1;	/* RxInt Enable */
}

void WaitTxEmpty(void)
{
#ifndef WINDBG
	while(SCI1.SCR.BIT.TIE == 1); /* while(txbuf is busy) */
	while(SCI1.SSR.BIT.TEND != 1); /* while(tx shift register is busy) */
#endif
}

/* bit to bit transfer (direct mode) */
void bit2bit(void)
{
	MSTCR.BIT.MSTOP4 = 1;	/* STBY SCI0 */
	WaitTxEmpty();
	MSTCR.BIT.MSTOP3 = 1;	/* STBY SCI1 */
	P9.DDR = 0xC3;			/* set TxD0,TxD1 to Output */

	sw = P2.DR.BYTE;		/* save dipsw */
	for(EVER) {
		P9.DR.BIT.B0 = P9.DR.BIT.B3; /* TxD0 = RxD1 */
		P9.DR.BIT.B1 = P9.DR.BIT.B2; /* TxD1 = RxD0 */
		if (sw != P2.DR.BYTE)	/* sw changed ? */
			break;
		if (captured!=NULL)				/* something received from IrDA */
			if (getIrcmd() == ST_EOL)
				break;
	}
	MSTCR.BIT.MSTOP3 = 0;	/* START SCI1 */
	initSCI(&SCI1,BAUD_16MH_9600);
	MSTCR.BIT.MSTOP4 = 0;	/* START SCI0 */
	initSCI(&SCI0,(unsigned char)((options.BIT.SPEED)? BAUD_16MH_9600:BAUD_16MH_4800));
}

/* put signon message */
void signon(void)
{
	char i,*p,v;

	SCI0.SCR.BIT.RIE = 0;	/* RxInt Disble */
	SCI1.SCR.BIT.RIE = 0;	/* RxInt Disble */

#ifndef WINDBG
	while(SCI1.SCR.BIT.TIE == 1); /* while(txbuf is busy) */
#endif

	txp = SIGNON;			/* set txbuf pointer */
	SCI1.SCR.BIT.TIE = 1;	/* TxInt Enable */

	while(SCI1.SCR.BIT.TIE == 1) /* while(txbuf is busy) */
#ifdef WINDBG
	sleep()
#endif
		;
	p = txbuf;
/*			" 0123456789012345678901234567890123456789012345678901234567890123"*/
	strcpy(p,"SPEED:0, ADCOFF:0, ECHO:0, RMC:0, SMAT:0, CERR:0, IRPHY:0, DMD:0, LCD:0, CLK:1/0\012\015\012\015");
	p = strchr(p,'0');
	if (options.BIT.SPEED)
		*p = '1';
	p = strchr(++p,'0');
	if (options.BIT.ADCOFF) {/* disable ADC */
		*p = '1';
	} else {
		if (ad0value & 0x3F)
			*p = 'I';  /* ignored */
		else
			*p = 'C';  /* connected */
	}
	p = strchr(++p,'0');
	if (options.BIT.ECHO)
		*p = '1';
	p = strchr(++p,'0');
	if (options.BIT.RMC)
		*p = '1';
	p = strchr(++p,'0');
	if (options.BIT.SMAT)
		*p = '1';
	p = strchr(++p,'0');
	if (options.BIT.CERR)
		*p = '1';
	p = strchr(++p,'0');
	if (options.BIT.IRPHY)
		*p = '1';
	p = strchr(++p,'0');
	if (options.BIT.DMD)
		*p = '1';
	p = strchr(++p,'0');
	if (LCDEquiped)
		*p = (char)((DA.DR0>>1) + ((LCDBL_BIT) ? 'A':'a'));
	p = strchr(++p,'0');
	for(i=DIVCR.BIT.DIV,v=1;i;i--) v*=2;
		*p = (char)(v+'0');

	txp = txbuf;			/* set txbuf pointer */
	SCI1.SCR.BIT.TIE = 1;	/* TxInt Enable */

	SCI0.SCR.BIT.RIE = 1;	/* RxInt Enable */
	SCI1.SCR.BIT.RIE = 1;	/* RxInt Enable */
}
/* --------------- RX0 ----------------*/
#ifdef ECHO_DEBUG
void RxInt1(void)
#else
/* NMEA */
void RxInt0(void)
#endif
{
	if ((SCI0.SSR.BYTE & 0x78)==0x40) {
		SCI0.SSR.BIT.RDRF = 0;
		(void) getsentence(SCI0.RDR);
		rerror = 0;
	} else {
		error |= ERR_RX0;
		capt = 0;	/* discard buffer */
		rerror++;
		SCI0.SSR.BIT.ORER = SCI0.SSR.BIT.FER = SCI0.SSR.BIT.PER = 0;
	}
}

/* --------------- RX1 ----------------*/
#ifdef ECHO_DEBUG
void RxInt0(void)
#else
void RxInt1(void)
#endif
{
	register char c;

	if ((SCI1.SSR.BYTE & 0x78)==0x40) {/* data exist,no receive error */
		SCI1.SSR.BIT.RDRF = 0;
		if ((c = SCI1.RDR) == ']') {
			monitor();
			strcpy(cmdbuf,"%SO");
			cmd = ST_EOL;
		} else
			cmd = getcmd(c);
	} else { /* error */
		SCI1.SSR.BIT.ORER = SCI1.SSR.BIT.FER = SCI1.SSR.BIT.PER = 0;
		error |= ERR_RX1;
		cmd = ST_IDL;
	}
	if (cmd != ST_FIL)
		cmdp = cmdbuf;		/* intialize pointer */
}

/* --------------- TX0 ----------------*/
/* initialize tx0 ring buffer */
void initTx0buf(void)
{
	tx0tp = tx0fp = tx0buf;
}
/* TX0 Ring Buffer */
/* top---tx0tp---tx0fp---end */

/* put 1 char to TX0 ring buffer */
unsigned char putTx0Buf(char c)
{
	register char *p;

	p = tx0fp;
	if (++p >= &tx0buf[MAXTX0BUF])
		p = tx0buf;
	if (p == tx0tp) {
		error |= ERR_TX0;
		return ST_OVF;	/* over flowed */
	}
	if (SCI0.SCR.BIT.TIE == 0) /* TxInt disabled ? */
		SCI0.SCR.BIT.TIE = 1; /* TxInt Enable */
	*(tx0fp = p) = c;
	return ST_FIL;
}

void TxInt0(void)
{
	if (tx0fp!=tx0tp){
		while(SCI0.SSR.BIT.TDRE != 1);
		++tx0tp;
		if (tx0tp >= &tx0buf[MAXTX0BUF])
			tx0tp = tx0buf;
		SCI0.TDR = *tx0tp;
		SCI0.SSR.BIT.TDRE = 0;
	} else {
		SCI0.SCR.BIT.TIE = 0; /* TxInt disable */
	}
}

/* ------------------- TX1 -------------------*/
/* put char to TX1 */
void TxInt1(void)
{
	if (*txp){
		while(SCI1.SSR.BIT.TDRE != 1);
		SCI1.TDR = *txp++;
		SCI1.SSR.BIT.TDRE = 0;	/* Send Start */
#ifdef WINDBG
		putchar(SCI1.TDR);
#endif
	} else {
		SCI1.SCR.BIT.TIE = 0; /* TxInt disable */
	}
}
/* -------------- AD converter ---------------*/
/* Kick start AD converter */
void kickAD(void)
{
	MSTCR.BIT.MSTOP0 = 0;	/* Enable A/D */
	AD.CSR.BYTE &= 0x7f;	/* clear ADF R&W */
	AD.CR.BIT.TRGE = 0;		/* disable external trigger */
	AD.CSR.BYTE = 0x71;		/* scan an0 & an1  */
}

/* AD complete */
void ADCInt(void)
{
	ad0value = AD.DRA;
	ad1value = AD.DRB;
	AD.CSR.BIT.ADF = 0;
	MSTCR.BIT.MSTOP0 = 1;	/* Disable A/D */
	if (ad0value < (1000 << 10)) { /* connected ? */
		fillALT( (int) ((ad0value*2273LU)>>16) ); /* 1023:2273 */
		data |= D_ALT;
	} else {
		ad0value = ADINVALID;
	}
}

/* get command string */
/* this code can't call at cmd == ST_EOL */
unsigned char getcmd(unsigned char c)
{
	if (c < ' ') {
		if (cmdp-cmdbuf < 3)	/* too short */
			return ST_IDL;
		*cmdp = '\000';			/* set EOL */
		return ST_EOL;
	}
	if (&cmdbuf[MAXCBUF-2] > cmdp) {
		if (('a'<=c) && (c <='z'))
			c -= 0x20;
		*cmdp++ = c;
		return ST_FIL;
	}
	/* buffer overflowed */
	return ST_OVF;
}

unsigned char getIrcmd(void)
{
	int c;

	if (IrRxStat) {	/* Buffer Over run */
		IrRxStat = 0;
		Ircmdp = Ircmdbuf;
	}
	if ((c = decodeIr()) < 0) {
		Ircmdp = Ircmdbuf;
		return ST_OTH;
	}
	if (&Ircmdbuf[MAXCBUF-2] > Ircmdp) {
		if (('a'<=c) && (c <='z')) c -= 0x20;
		if ((*Ircmdp++ = (char)c) >= ' ')
			return ST_FIL;
	} else {	/* buffer overflowed, discard buffer */
		Ircmdp = Ircmdbuf;
		return ST_OVF;
	}
	*(Ircmdp-1) = '\000';
	Ircmdp = Ircmdbuf;
	return ST_EOL;
}

void switched(unsigned char val)
{
	opt_t opt;

	opt.BYTE = val;
	options.BYTE = (unsigned char)(options.BYTE ^ opt.BYTE) ;

	if (opt.BIT.SPEED)
		initSCI(&SCI0,(unsigned char)((options.BIT.SPEED)? BAUD_16MH_9600:BAUD_16MH_4800));
	/* (opt.BIT.ADCOFF) *//* 0:AUTO,1:OFF - use ADC for Alitude */
	/* (opt.BIT.ECHO)	*//* 0:OFF,1:ON - ECHO */
	/* (opt.BIT.RMC)	*//* 0:ALL,1:RMC - use RMC location only */
	if ((opt.BIT.SMAT)||(opt.BIT.DMD))	/* 0:IPS,1:SMAT - output format */
		initg2i();
	if (opt.BIT.IRPHY) {
		if (options.BIT.IRPHY)
			initIrPHY();
	}
	/* (opt.BIT.CERR)	*//* 0:Check,1:ignore - NMEA Check sum */
	/* (opt.BIT.CNVT)	*//* 0:THROUGH,1:WGS->TKY - convert datum */
	/* (opt.BIT.DMD)	*//* 0:DMS,1:DMD - LAT,LON format */
}

/* parse command */
static const char cmds[] =
/*	0  1  2	 3	4  5  6	 7	8  9 10 11 12 13 14 15 16 17 18 19 20*/
 "%SO%MN%08%12%DI%RM%AL@SK@DM@KE@KT%AD%EC%CK%CS%48%96%IR%LC%BL%DT";
unsigned char parse(char *p)
{
	char *q,r;
	opt_t val;

	r = *(p+3);
	*(p+3)= '\000';

	val.BYTE = options.BYTE;
	if ((q = strstr(cmds,p)) == NULL)
		return 1;
	switch(((unsigned char)(q-cmds))/3) {
	case 0:
		WaitTxEmpty();
		signon();
		break;
	case 1:
		WaitTxEmpty();
#ifndef WINDBG
		if (options.BIT.IRPHY)
			while(ITU0.TIER.BIT.IMIEA);		/* IrTx Idle ? */
#endif
		monitor();
		signon();
		break;
	case 2:
		val.BIT.SMAT = 0;
		break;
	case 3:
		val.BIT.SMAT = 1;
		break;
	case 4:
		bit2bit();
		break;
	case 5:
		val.BIT.RMC = 1;
		break;
	case 6:
		val.BIT.RMC = 0;
		break;
	case 7:
		if ((gpstype != 'G') || (ipsbuf[IPS_DATUM_POS] > 'C'))
			ipsbuf[IPS_DATUM_POS] = r;
		break;
	case 8:/* @DM */
		/* alphabetic:DMS, numeric:DMD, NMEA is DM.D */
		if (r == 'D')
			val.BIT.DMD = 1;
		else if (r == 'S')
			val.BIT.DMD = 0;
		break;
	case  9: /* @KE */
		val.BIT.SMAT = 1;
		break;
	case 10: /* @KT */
		val.BIT.SMAT = 0;
		break;
	case 11: /* %AD */
		if (r == '0')
			val.BIT.ADCOFF = 1;
		else
			val.BIT.ADCOFF = 0;
		break;
	case 12: /* %EC */
		if (r == '0')
			val.BIT.ECHO = 0;
		else
			val.BIT.ECHO = 1;
		break;
	case 13: /* %CK */
		WaitTxEmpty();
#ifndef WINDBG
		if (options.BIT.IRPHY)
			while(ITU0.TIER.BIT.IMIEA);		/* IrTx Idle ? */
#endif
		r -= '0';
		if (r < 0) r = 0;
		if (r > 2) r = 2;
		gear = (unsigned char) r;
		reset();
		break;		/* this line never execute */
	case 14: /* %CS */
		if (r == '0')
			val.BIT.CERR = 0;
		else
			val.BIT.CERR = 1;
		break;
	case 15: /* %48 */
		val.BIT.SPEED = 0;
		break;
	case 16: /* %96 */
		val.BIT.SPEED = 1;
		break;
	case 17:
		if (r == '0')
			val.BIT.IRPHY = 0;
		else
			val.BIT.IRPHY = 1;
		break;
	case 18: /* %LC */
		lcdcontrast(r);
		break;
	case 19: /* %BL */
		if (r == '0')
			LCDBL_BIT = 0;
		else
			LCDBL_BIT = 1;
		break;
#ifdef DTMF
	case 20: /* %DT */
		*(p+3) = r;	/* restore */
		strcpy(dtmfbuf,p+3);
		dtmftxp = dtmfbuf;
		kickDTMF();
		break;
#endif
	default:
		break;
	}
	if ((val.BYTE = (unsigned char)(val.BYTE ^ options.BYTE))!=0)
		switched(val.BYTE);
	return 0;
}

void lcdcontrast(char c)
{
	if (c == '-') {
		if (DA.DR0 < 48)
			DA.DR0 += 2;
		return;
	}
	if (c == '+') {
		if (DA.DR0 >1)
			DA.DR0 -= 2;
		return;
	}
	c &= 0xdf;
	if ( (c>='A') && (c<='Z') )
		DA.DR0 = (unsigned char)((c - 'A')*2);
}


#define T_16M_9600	417	 /* 16MHz/4 9600*/
#define TP_16M_9600	 16	 /* pulse width 4 micro sec */


#define SAMP_16M_9600 (417+21)	 /* 16MHz/4 9600 +5% */

int makIrPat(char c,unsigned buf[])
{
	unsigned char i,j;
	unsigned u;

	j=0;
	u = ITU0.GRA;				/* get start bit up edge */
	buf[j++] = u + TP_16M_9600; /* start bit down edge */
	for (i=1; i < 9 ;c>>=1,i++) {
			 u += T_16M_9600;
		if ((c & 1)== 0) {
			buf[j++] = u;				   /* up edge */
#ifndef WINDBG
			buf[j++] = u + TP_16M_9600;	   /* down edge */
#endif
		}
	}
	buf[j++] = u + T_16M_9600 + T_16M_9600;
	return j;
}

void initIrPHY(void)
{
	if (ITU1.TIOR.BIT.IOA == 4)	/* Already initialized ? */
		return;
	MSTCR.BIT.MSTOP5 = 0;		/* Enable ITU */
	MSTCR.BIT.MSTOP2 = 0;		/* Enable DMAC */

	/* counter 0 */
	ITU.TSNC.BIT.SYNC0 = 0;		/* NO SYNC OPERATION */
	ITU.TMDR.BIT.PWM0 = 0;		/* NO PWM MODE */
	/* counter 1 */
	ITU.TSNC.BIT.SYNC1 = 0;		/* NO SYNC OPERATION */
	ITU.TMDR.BIT.PWM1 = 0;		/* NO PWM MODE */

	ITU0.TCR.BYTE = ITU1.TCR.BYTE = (unsigned char)(2 - (DIVCR.BYTE&3));/* NON STOP,1/4 Clock */

	ITU0.TIOR.BIT.IOA = 1;		/* compare match, next low */

	ITU1.TIOR.BIT.IOA = 4;		/* capture rising edge */
	ITU1.TIOR.BIT.IOB = 0;		/* compare match ignore */

	ITU.TSTR.BIT.STR0 = 1;		/* start counter 0 */
	ITU.TSTR.BIT.STR1 = 1;		/* start counter 1 */
	startIrRx0();
}

void startIrRx0(void)
{
	ITU1.TSR.BIT.IMFA = 0;		/* clear GRA capture INT */
	ITU1.TIER.BIT.IMIEA = 1;	/* enable GRA capture INT */
	ITU1.TIER.BIT.IMIEB = 0;	/* disable GRB compare INT */
	DMAC0.DTCRA.BYTE = 0x47;	/* Word,FIXED,ITE IRQ Disable,Block mode */
	DMAC0.DTCRB.BYTE = 0x19;	/* inc,block is source,ITU1-GRA-INT */
	DMAC0.MARA = (void *)&ITU1.GRA;	/* source address */
	DMAC0.ETCRA = 0x0101;		/* block size */
	captbufp = NULL;			/* no data */
}

#define IR_FRAMING_ERROR 0x81
#define IR_BUFFER_OVERRUN 0x82
#define IR_DATA_READY 0x80

/* capture GRA int , compare GRB int */
/* int 28, int 29 */
/* We expect start bit captured now. */
void IrRxPeriodInt(void)
{
	unsigned *p;
	int dt,dl;

	DMAC0.DTCRB.BIT.DTME = 0;		/* stop DMAC */
	DMAC0.DTCRA.BIT.DTE = 0;		/* stop DMAC */

	p = DMAC0.MARB;					/* next buffer address */
	if (captbufp != NULL) {			/* previous sample exist ? */
		dt = *(p-1) - *(captbufp);	/* check last edge */
		if (dt < 0) dt = -dt;
		if (dt < SAMP_16M_9600*9)	/* no next start bit */
			*p++ = ITU1.GRB;		/* dummy start bit set */
		*p = *(p-1);				/* mark end of buffer */
		dl = *(p-2) - *(p-1);		/* check last data edge */
		if (dl < 0) dl = -dl;
		/* missing stop bit or too many edge */
		if ((dl < SAMP_16M_9600)||(DMAC0.ETCRB == 0)){
			IrRxStat = IR_FRAMING_ERROR;
			dt = 0;
		} else {/* we have data */
			if (captured == NULL)	/* buffer empty ? */
				captured = captbufp;
			else
				IrRxStat = IR_BUFFER_OVERRUN;
		}
	} else {/* no previous data */
		dt = SAMP_16M_9600*10;
	}

	if (dt > SAMP_16M_9600*9) { /* we got start bit */
		if (captured == captbuf0)	/* select not used buffer */
			captbufp = captbuf1;	/* buffer address */
		else
			captbufp = captbuf0;	/* buffer address */

		*captbufp = ITU1.GRA;		/* set start bit timing */
		ITU1.GRB = *captbufp + SAMP_16M_9600*10;	/* set sampling period */

		/* start sample */
		DMAC0.MARB = captbufp+1;	/* destination address */
		DMAC0.ETCRB = 10;			/* maximum sampling+1 */
		DMAC0.DTCRB.BIT.DTME = 1;	/* Enable DMAC */
		DMAC0.DTCRA.BIT.DTE = 1;	/* Enable DMAC */
		ITU1.TSR.BIT.IMFA = 0;		/* clear GRA capture INT for DMA */
		ITU1.TSR.BIT.IMFB = 0;		/* clear GRB compare INT */
		ITU1.TIER.BIT.IMIEB = 1;	/* Enable GRB compare INT */
	} else {
		startIrRx0();	/* wait for start bit */
	}
}

void kickIrTx0()
{
	ITU1.TIER.BIT.IMIEB = 0;	/* Disable GRB compare INT(Receive inhibit) */
	ITU.TSTR.BIT.STR0 = 0;		/* stop counter for setup */
	ITU0.TCNT = 0;
	ITU0.GRA = 1;
	DMAC0A.IOAR = (unsigned char)(&ITU0.GRA); /* I/O address */
	DMAC0B.DTCR.BIT.DTIE = 0;  /* Disable DMAC0 B ch */
	DMAC0A.DTCR.BYTE = 0x48;   /* Word,INC,I/O,ITE IRQ Enable,ITU0-GRA-INT */
	/* DTE=0,ITIE=1 interrupt generated */
#ifdef WINDBG
	IrTxEndInt();
#endif
	while(DMAC0A.DTCR.BIT.DTE == 0);	/* interrupt routine called ? */
	ITU0.TSR.BIT.IMFA = 0;		/* clear GRA compare INT for DMA */
	ITU0.TIER.BIT.IMIEA = 1;	/* enable GRA INT */
	ITU0.TIOR.BIT.IOA = 3;		/* next edge logic level = toggle */
	ITU.TSTR.BIT.STR0 = 1;		/* start counter */
}

/* DMAC0A end int */
void IrTxEndInt(void)
{
	if (*irtxp){				/* next data exist ? */
		DMAC0A.MAR = edgebuf0;	/* memory address */
		DMAC0A.ETCR = makIrPat(*irtxp++,edgebuf0); /* make edges */
		DMAC0A.DTCR.BIT.DTE = 1;/* Enable DMAC */
	} else {
		/* stop Tx and wait for start bit */
		ITU0.TIOR.BIT.IOA = 1;	/* compare match, logic level = 0 */
		ITU0.TIER.BIT.IMIEA = 0;/* disable GRA INT */
		startIrRx0();			/* wait for start bit */
	}
}

int decodeIr(void)
{
	unsigned *p;
	int c,t;

	p = captured;
	for (c=0x1000,t=0; (c&0x1) == 0;c >>= 1) {
		if (t > SAMP_16M_9600) {
			c |= 0x2000;
			t -= SAMP_16M_9600;
		} else {
			if ((t = *(p+1) - *p)!=0)
				p++;
			if (t < 0 )
				t = -t;
		}
	}
	captured = NULL;
	/*	check stop bit and no extraneous data */
	if (((c & 0x400) == 0) || (*(p+1) != *p) ){ /* framing error */
		Ircmdp = Ircmdbuf;
		return -1;		/* discard buffer */
	}
	/* strip stop, start, marker bit sddddddddsm*/
	return	(c >> 2) & 0xff;
}

#define T16M_15ms  240000L
#define T16M_1P64ms 26240L
#define T16M_4P1ms	65600L
#define T16M_0P1ms	 1600L
#define T16M_40micro  640L
#define T16M_450ns		7L

#if LCDIF == 4
/* based on AKI H8 Mother sample mtest.mar */
/* R/W signal = 'W' fixed.. */
/* can't read busy flag, so wait timer */
void lcd_out8(unsigned char data, unsigned char select)
{
	LCD_RS_SIG = select;
	LCD_E_SIG = 1;
	LCD_PORT = data;
	clk_wait(T16M_450ns,WAIT);
	LCD_E_SIG = 0;
	clk_wait(T16M_450ns,WAIT);
}

void reset_lcd4(void)
{
	LCDEquiped = (char)(LCDTYP);	/* check LCD Type */

	LCDBLENB;				/* LCD BL output port enable */
	DA.CR.BIT.DAOE0 = 1;	/* DA0 output enable */
	DA.DR0 = LCD_CONT;		/* default contrast */

	LCD_DDR_OUT;			/* set output */

	clk_wait(T16M_15ms,WAIT);

	lcd_out8(0x23,LCD_INST);
	clk_wait(T16M_4P1ms,WAIT);

	lcd_out8(0x23,LCD_INST);
	clk_wait(T16M_4P1ms,WAIT);

	lcd_out8(0x23,LCD_INST);
	clk_wait(T16M_4P1ms,WAIT);

	lcd_out8(0x22,LCD_INST);
	clk_wait(T16M_4P1ms,WAIT);

	write_lcd4(0x28,LCD_INST);
	clk_wait(T16M_4P1ms,WAIT);
	write_lcd4(0x0E,LCD_INST);
	clk_wait(T16M_4P1ms,WAIT);
	write_lcd4(0x06,LCD_INST);
	clk_wait(T16M_4P1ms,WAIT);

	LCD_DDR_IN;			/* set input */
#ifdef WINDBG
	LCD_PORT = 0xff;
#endif
	if (LCD_HGH_INP) { /* high impedance ? */
		LCD_DDR_OUT;
		put_lcd(SIGNONLCD);
		return;
	}
	LCDEquiped = 0;
	return;
}

unsigned char rd_lcd4(unsigned char select)
{
	if (RFSHC.RTMCSR.BIT.CMF == 0)
		return 0x80;	/* busy */
	MSTCR.BIT.MSTOP1 = 1;
	return 0;
}

void write_lcd4(unsigned char data, unsigned char select)
{
	LCD_DDR_OUT;		/* set output */
	LCD_RS_SIG = select;

	LCD_E_SIG = 1;
	LCD_PORT =(LCD_PORT&0x30) |( data >> 4);
	clk_wait(T16M_450ns,WAIT);
	LCD_E_SIG = 0;
	clk_wait(T16M_450ns,WAIT);

	LCD_E_SIG = 1;
	LCD_PORT =(LCD_PORT&0x30) |( data & 0xf);
	clk_wait(T16M_450ns,WAIT);
	LCD_E_SIG = 0;	/* set E low */
	switch(data){
	case 001:	/* clear display 1.64ms */
	case 002:	/* cursor at home */
		clk_wait(T16M_1P64ms,WAIT);
		break;
	default:
		clk_wait(T16M_40micro,WAIT);
		break;
	}
}
#else
/************************************************************/
/* Interface between H8/3048F to HD44780 LCD */
/* based on Hitachi A/N APPS/059/1.0(this code can't reset...)
/* Port 3: Data port DB0 to DB7 connected to 44780 */
/* Port 4: Control Port , only bit 5 to 7 are used */
/* Port 4,7: E-Signal */
/* Port 4,6: R/W - Signal */
/* Port 4,5: RS - Signal */
/************************************************************/
void reset_lcd8(void)
{
	LCDEquiped = (char)(LCD_TYP_BIT+1);	/* check LCD Type */
	LCD_E_SIG = 0;		/* disable */
	LCD_DDR_OUT;		/* set output */
	LCD_PORT = 0;		/* write 0 */
	LCD_DDR_IN;			/* set input */
#ifdef WINDBG
	LCD_PORT = 0xff;
#endif
	if (LCD_HGH_INP) {/* high impedance ? */
		LCDBLENB;				/* LCD BL output port enable */
		DA.CR.BIT.DAOE0 = 1;	/* DA0 output enable */
		DA.DR0 = LCD_CONT;		/* default contrast */

		clk_wait(T16M_15ms,WAIT);
		write_lcd8(FUNCTION_SET_8,LCD_INST);
		clk_wait(T16M_4P1ms,WAIT);
		write_lcd8(FUNCTION_SET_8,LCD_INST);
		clk_wait(T16M_0P1ms,WAIT);
		write_lcd8(FUNCTION_SET_8,LCD_INST);
		clk_wait(T16M_0P1ms,WAIT);
		if ((rd_lcd8(LCD_INST) & 0x80) == 0) {
			write_lcd8(FUNCTION_SET_8,LCD_INST);
			put_lcd(SIGNONLCD);
			return;
		}
	}
	LCDEquiped = 0;
	return;
}

unsigned char rd_lcd8 (unsigned char select)
/*************************************************
Abstract: read one byte of data from 44780
Parameters: data= data value to be written to 44780
select= select data or instructions
equal 0 -> instruction write selected
equal 1 -> data write is selected
Return: Data that was read from 44780
************************************************/
{
	unsigned char i;

	LCD_DDR_IN; /* set data port to input */
	LCD_RS_SIG = select; /* set RS */
	LCD_RW_SIG = 1; /* set R/W high */
	LCD_E_SIG = 1; /* set E high */
	i = LCD_PORT; /* read one byte from lcd */
#ifdef WINDBG
	i &= 0x7f;
#endif
	LCD_E_SIG = 0; /* set E low */
	return (i);
}

void write_lcd8(unsigned char data, unsigned char select)
/*************************************************
Abstract: Write data or instruction to 44780
Parameters: data= data value to be written to 44780
select= select data or instructions
equal 0 -> instruction write selected
equal 1 -> data write is selected
Return: None
************************************************/
{
	LCD_RS_SIG = select;/* set RS signal */
	LCD_RW_SIG = 0;		/* set R/W low */
	LCD_DDR_OUT;		/* set data port to output */
	LCD_PORT = data;	/* write data to LCDII */
	LCD_E_SIG = 1;		/* set E high */
	clk_wait(T16M_450ns,WAIT);
	LCD_E_SIG = 0;		/* set E low */
}
#endif

void put_lcd(const char *p)
{
	while (*p) {
		while (rd_lcd(LCD_INST) & 0x80);	/* busy wait */
		if (*p < ' ')
			write_lcd(*p++,LCD_INST);
		else
			write_lcd(*p++,LCD_DATA);
	}
}

void maklcddata(void)
{
	char *p,*q;
	int i;

	p = lcdbuf;
	*p++ = RETURN_HOME;

	switch(LCDEquiped) {
	case 1:
		for(i = IPS_LAT_VAL_LEN+IPS_LAT_DIR_LEN, q = &ipsbuf[IPS_LAT_DIR_POS]; i ;--i)
			*p++ = *q++;
		*p++ = ' ';
		for(i = IPS_SPEED_LEN, q = &ipsbuf[IPS_SPEED_POS]; i ;--i)
			*p++ = *q++;
		*p++ = ' ';
		for(i = IPS_COURSE_LEN, q = &ipsbuf[IPS_COURSE_POS]; i ;--i)
			*p++ = *q++;
		*p++ = NEXT_LINE;
		for(i = IPS_LON_VAL_LEN+IPS_LON_DIR_LEN, q = &ipsbuf[IPS_LON_DIR_POS]; i ;--i)
			*p++ = *q++;
		for(i = IPS_HGH_SGN_LEN+IPS_HGH_VAL_LEN, q = &ipsbuf[IPS_HGH_SGN_POS]; i ;--i)
			*p++ = *q++;
		*p++ = ' ';
		*p++ = ipsbuf[IPS_MODE_POS];
		*p = '\0';
		break;
	case 2:
		/* N DD MM'SS.S" */
		q = &ipsbuf[IPS_LAT_DIR_POS];
		*p++ = *q++;
		*p++ = ' ';
		*p++ = *q++;
		*p++ = *q++;
		*p++ = '\337';
		*p++ = *q++;
		*p++ = *q++;
		*p++ = 0x27;
		*p++ = *q++;
		*p++ = *q++;
		*p++ = '.';
		*p++ = *q++;
		*p++ = 0x22;
		*p++ = ' ';
		/* EDDD MM'SS.S" */
		*p++ = NEXT_LINE;
		q = &ipsbuf[IPS_LON_DIR_POS];
		*p++ = *q++;
		*p++ = *q++;
		*p++ = *q++;
		*p++ = *q++;
		*p++ = '\337';
		*p++ = *q++;
		*p++ = *q++;
		*p++ = 0x27;
		*p++ = *q++;
		*p++ = *q++;
		*p++ = '.';
		*p++ = *q++;
		*p++ = 0x22;
		/* +0000m  000Km/h */
		*p++ = THIRD_LINE;
		q = &ipsbuf[IPS_HGH_SGN_POS];
		for(i = IPS_HGH_SGN_LEN+IPS_HGH_VAL_LEN; i ;--i)
			*p++ = *q++;
		*p++ = 'm';
		*p++ = ' ';
		*p++ = ' ';
		for(i = IPS_SPEED_LEN, q = &ipsbuf[IPS_SPEED_POS]; i ;--i)
			*p++ = *q++;
		*p++ = 'K';
		*p++ = 'm';
		*p++ = '/';
		*p++ = 'h';
#if 0
		/* YY/MM/DD(dw)HH:MM:SS */
		{
			unsigned char *r;
			q = &ipsbuf[IPS_MES_DATE_POS];
			*p++ = *q++;
			*p++ = *q++;
			*p++ = '/';
			*p++ = *q++;
			*p++ = *q++;
			*p++ = '/';
			*p++ = *q++;
			*p++ = *q++;
			*p++ = '(';
			r = "SuMoTuWeThFrSa";
			r += (*q++ - '0')*2;
			*p++ = *r++;
			*p++ = *r++;
			*p++ = ')';
			*p++ = *q++;
			*p++ = *q++;
			*p++ = ':';
			*p++ = *q++;
			*p++ = *q++;
			*p++ = ':';
			*p++ = *q++;
			*p++ = *q++;
		}
#endif
		/* TRACK:000  MODE:4 */
		*p++ = FOURTH_LINE;
		q = "TRACK:";
		while (*q)
			*p++ = *q++;
		for(i = IPS_COURSE_LEN,q = &ipsbuf[IPS_COURSE_POS]; i;--i)
			*p++ = *q++;
		*p++ = '\337';
		q = " MODE:";
		while (*q)
			*p++ = *q++;
		*p++ = ipsbuf[IPS_MODE_POS];
		/*no break */
	default:
		break;
	}
	*p = '\0';
}

/* wait n OSC(not fai) clock */
/* max.1048575 at 1/1 */
void clk_wait(long t,unsigned char wait)
{
	unsigned char n;

	MSTCR.BIT.MSTOP1 = 0;			/* enable refresh counter */
	t >>= DIVCR.BIT.DIV + 1;		/* scaling */
	for (n = 1; t>255 ; t >>=2,n++);
	RFSHC.RTCNT = 0;				/* counter zero clear */
	RFSHC.RTMCSR.BIT.CMF = 0;		/* compare match flag clear */
	RFSHC.RTCOR = (unsigned char)t;	/* set time */
	RFSHC.RTMCSR.BIT.CKS = n;		/* clock input and start timer */
#ifdef WINDBG
	RFSHC.RTMCSR.BIT.CMF = 1;
#endif
	if (wait == NOWAIT)
		return;
	while(RFSHC.RTMCSR.BIT.CMF == 0);
	MSTCR.BIT.MSTOP1 = 1;
}

/* hardware reset generate by watch dog timer */
void reset(void)
{
	WDG_W_TCSR_TCNT = 0xA560;	/* write TCSR */
	WDG_W_TCSR_TCNT = 0x5AFF;	/* write TCNT 0xff */
	/* watch dog timer overflow reset */
}
#endif
/* -- V1.03 -- */
/* IR remote control */
void initIrRCRx(void)
{
	RCVal = 0;
	RCBit = 0;
	RCCode = 0xff;

	strcpy(RCstr,"SYS1");
	RCstr[6] = '\015';
	RCstr[7] = '\012';
	RCstr[8] = '\0';

	if (ITU2.TIOR.BIT.IOA == 4)	/* Already initialized ? */
		return;
	MSTCR.BIT.MSTOP5 = 0;		/* Enable ITU */

	/* counter 2 */
	ITU.TSNC.BIT.SYNC2 = 0;		/* NO SYNC OPERATION */
	ITU.TMDR.BIT.PWM2 = 0;		/* NO PWM MODE */

	ITU2.TCR.BIT.TPSC = (unsigned char)(2 - (DIVCR.BYTE&3)); /* 1/4 Clock */
	ITU2.TCR.BIT.CCLR = 1;		/* CLR GRA	*/

	ITU2.TIOR.BIT.IOA = 4;		/* capture rising edge */
	ITU2.TIOR.BIT.IOB = 0;		/* compare match ignore */

	ITU2.TIER.BIT.IMIEA = 1;	/* enable GRA capture INT */
	ITU.TSTR.BIT.STR2 = 1;		/* start counter 2 */
}

void IrRCRxInt(void)
{
	ITU2.TSR.BIT.IMFA = 0;	/* clear INT */
	if ((ITU2.TSR.BIT.OVF == 1) || (ITU2.GRA > 10000 )) {	/* we get header */
		RCVal = 0;
		RCBit = 0;
		ITU2.TSR.BIT.OVF = 0;	/* clear overflow */
	} else {
		RCVal <<= 1;
		RCBit++;
		if (ITU2.GRA > 5000)
			RCVal |= 1;
		if (RCBit == 32) {
			if ( ((RCVal >> 16) == 0x41ca)
				&& ((((RCVal>>8) & 0xff) ^ (RCVal & 0xff)) == 0xff) )
				/* we get code */
				RCCode = (RCVal>>8) & 0xff;
			else
				RCCode = 0xff;
		}
	}
}
/* End of H8 specific code */

/* =========== common routines =========== */
/* initialize ips buffer */
void initg2i(void)
{
	register char *p,*q;
	unsigned char sat;

	max_sat = (unsigned char)((options.BIT.SMAT) ? 12:8);
	if (strncmp(ipsbuf,"SONY81",IPS_ID_LEN) == 0)
		sat = 8;
	else if (strncmp(ipsbuf,"SMATC0",IPS_ID_LEN) == 0)
		sat = 12;
	else
		sat = 0;
	if (sat != max_sat) {
		strncpy(ipsbuf,(max_sat == 12) ? "SMATC0":"SONY81",IPS_ID_LEN);
		p = &ipsbuf[IPS_SAT_SER_POS + ((sat<max_sat)?sat:max_sat)*IPS_SAT_LEN];
		q = &ipsbuf[IPS_SAT_SER_POS + max_sat*IPS_SAT_LEN];
		while(p<q) {
			*p++ = '_';
			*p++ = '_';
			*p++ = '_';
			*p++ = 'A';
			*p++ = 'A';
		}
		*p++ = 'A';
		*p++ = 'D';
		*p++ = 'B';
		*p++ = (char)((options.BIT.DMD) ? '9':'E');
#ifndef FILTER
#ifndef WINDBG
		*++p = '\015';
#endif
		*++p = '\012';
#endif
		*++p = '\0';
	}
}

/* get sentence from stream */
unsigned char getsentence(unsigned char c)
{
#ifndef FILTER
	if (options.BIT.ECHO)	/* echo back */
		(void) putTx0Buf(c);
#endif
#ifdef ECHO_DEBUG
	if (c == ']') {
		monitor();
		signon();
		return ST_OTH;
	}
#endif
	if (c == '$') {
		capt = c;
		sump = lbufp = lbufip;
		csum = 0;
		return ST_INI;
	}
	if (capt != 0) {
		if (c < ' ') {
			capt = 0;
			*lbufp = '\0';
#ifdef AUTO_CERR
			if (sump == lbufip)	/* check sum not found ? */
				options.BIT.CERR = 1;	/* ignore checksum */
#endif
			if (lbufpp == NULL) {
				lbufpp = lbufip;
				if (lbufip != lbuf0)
					lbufip = lbuf0;
				else
					lbufip = lbuf1;
				return ST_EOL;
			}
			return ST_OVF;
		}
		if (lbufip+MAXLBUF-2 > lbufp) {
			*lbufp++ = c;

			if (c == '*') {
				sump = lbufp;
				capt = c;
			}
			if (capt != '*') {
				csum ^= c;
				if (lbufp-lbufip == 5) {
					switch (styp = csum){
					case C_GPRMC:
						LEDON;		/* LED on for start $GPRMC */
						/* no break; */
					case C_GPGSV:
					case C_GPGGA:
					case C_GPGSA:
					case C_PGRMM:
					case C_GPGLL:
						break;
					default:
						if (*lbufip == 'P')
							gpstype = *(lbufip+1);
						capt = 0;
						break;
					}
				}
			}
			return ST_FIL;
		} else {	/* buffer overflowed, discard buffer */
			capt = 0;
			return ST_OVF;
		}
	}
	return ST_OTH;
}

/* build IPS string from NMEA sentence */
unsigned char buildips(char *cp)
{
	register char *p,*q;
	register unsigned char par,pcnt;

	pcnt = sep(cp);
	switch (styp){
	case C_GPGSV:
		if ((strcmp(param[0],"GPGSV") == 0) && (pcnt >= 4))
			gpgsv(pcnt);
		break;
	case C_GPGGA:
		if ( (strcmp(param[0],"GPGGA") == 0) && (pcnt >= 11) )
			gpgga();
		break;
	case C_GPRMC:
		if ( (strcmp(param[0],"GPRMC") == 0) && (pcnt >= 9) )
			gprmc();
		break;
	case C_GPGSA:
		if ( (strcmp(param[0],"GPGSA") == 0) && (pcnt >= 15) )
			gpgsa();
		break;
	case C_PGRMM:
		if ( (strcmp(param[0],"PGRMM") == 0) && (pcnt >= 1) )
			pgrmm();
		break;
	case C_GPGLL:
		if ( (strcmp(param[0],"GPGLL") == 0) && (pcnt >= 5) )
			gpgll();
		break;
	default:
		break;
	}
	if (data == GP_ALL) {
		q = &ipsbuf[IPS_PAR_POS + max_sat*5];
		for (par=0,p = ipsbuf ; p < q ; par = (unsigned char)(par + *p++));
		*q = (char) ((par & 1) ? 'O':'E');
		data &= (options.BIT.RMC == 0) ? ~D_POS : D_DATE;
		par = ST_BSY0;
		if (options.BIT.IRPHY) par |= ST_BSY1;
		if (LCDEquiped) par |= ST_BSY2;
		return par;
	}
	return ST_EOL;
}

void gprmc(void)
{
	register char *p,*q;
	register unsigned u,d;

	if (*(p = param[9]) != '\0') {
		if ((strncmp(p,datebuf,IPS_UTC_DATE_LEN) != 0) || ((data & D_DATE)==0)){
			strncpy(datebuf,p,IPS_UTC_DATE_LEN);
			ipsbuf[IPS_UTC_WEEK_POS] =
				calwday( (unsigned)((*(p+4)-'0')*10 + *(p+5)-'0')
				, (unsigned)(((*(p+2)-'0')*10 + *(p+3)-'0')-1)
				, (unsigned)((*(p)-'0')*10 + *(p+1)-'0')
				);
			ipsbuf[IPS_UTC_DATE_POS+4] = *p++;
			ipsbuf[IPS_UTC_DATE_POS+5] = *p++;
			ipsbuf[IPS_UTC_DATE_POS+2] = *p++;
			ipsbuf[IPS_UTC_DATE_POS+3] = *p++;
			ipsbuf[IPS_UTC_DATE_POS+0] = *p++;
			ipsbuf[IPS_UTC_DATE_POS+1] = *p;
			memset(&ipsbuf[IPS_UTC_TIME_POS],' ',IPS_UTC_TIME_LEN);
			data |= D_DATE;
		}
	}
	if (timchk(1) != 0) {
		if (*(p = param[3]) != '\0')
			strFcpy(&ipsbuf[IPS_LAT_VAL_POS],p,IPS_LAT_VAL_LEN);	/* copy LAT value without */
		if (*(p = param[4]) != '\0')							/* copy LAT direction */
			ipsbuf[IPS_LAT_DIR_POS]= *p;
		if (*(p = param[5]) != '\0')
			strFcpy(&ipsbuf[IPS_LON_VAL_POS],p,IPS_LON_VAL_LEN);	/* copy LON value without "." */
		if (*(p = param[6]) != '\0')
			ipsbuf[IPS_LON_DIR_POS]= *p;							/* copy LON direction */
		data |= D_POS;
	}
	if (*(p = param[7]) != '\0') {
		u = (unsigned)(((unsigned long)atoi(p)*1897U)>>10);		/* set speed x1.851851 */
		q = &ipsbuf[IPS_SPEED_POS];
		if (u > 999) u = 999;
		for (d=100;d>0;d /= 10) {
			*q++ = (char)(u/d + '0');
			u %= d;
		}
	}
	if (*(p = param[8]) != '\0') { /* set course */
		u = (unsigned) atoi(p);
		q = &ipsbuf[IPS_COURSE_POS];
		for (d=100;d>0;d /= 10) {
			*q++ = (char)(u/d + '0');
			u %= d;
		}
	}
	if	(*param[2] == 'A') {/* GPS receiver status */
		/* copy date & time at measure */
		strncpy(&ipsbuf[IPS_MES_DATE_POS],&ipsbuf[IPS_UTC_DATE_POS],IPS_TIME_STAMP_LEN);
	} else {
		ipsbuf[IPS_LAT_DIR_POS] |= 0x20;
	}
	data |= GP_RMC;
}
void gpgga(void)
{
	register char *p;

	if (timchk(1) != 0) {
		if (*(p = param[2]) != '\0')
			strFcpy(&ipsbuf[IPS_LAT_VAL_POS],p,IPS_LAT_VAL_LEN);	/* copy LAT value without */
		if (*(p = param[3]) != '\0')							/* copy LAT direction */
			ipsbuf[IPS_LAT_DIR_POS]= *p;
		if (*(p = param[4]) != '\0')
			strFcpy(&ipsbuf[IPS_LON_VAL_POS],p,IPS_LON_VAL_LEN);	/* copy LON value without "." */
		if (*(p = param[5]) != '\0')
			ipsbuf[IPS_LON_DIR_POS]= *p;							/* copy LON direction */
		data |= D_POS;
	}
#if 0
	if (*(p = param[7]) != '\0')
		tracked = atoi(p); /* Number of satellites being tracked	 */
	/* HDOP not use yet (8) */
#endif
	if	(*param[6] > '0') { /* GPS receiver status */
		strncpy(&ipsbuf[IPS_MES_DATE_POS],&ipsbuf[IPS_UTC_DATE_POS],IPS_TIME_STAMP_LEN);
	} else {
		ipsbuf[IPS_LAT_DIR_POS] |= 0x20;
	}
	if (ad0value == ADINVALID) { /* AD converter not used or invalid value */
		if (*(p = param[9]) != '\0')
			fillALT(atoi(p));
		data |= D_ALT;
	}
}
void gpgsa(void)
{
	register char *p;
	register unsigned char dop;
	register int v;

	ipsbuf[IPS_MODE_POS] = (char) ((*param[2] == '3')? '4': '3'); /* GPS receiver status */
	dop = 16;	/* not fix */
	if (*(p = param[(ipsbuf[IPS_MODE_POS]=='3') ? 14:15]) != '\0') {
		if ((v = atoi(p)) < 10)
			dop = (unsigned char)v;
		else if (v<12 )
			dop = 10;
		else if (v<15)
			dop = 11;
		else if (v<20)
			dop = 12;
		else if (v<30)
			dop = 13;
		else if (v<50)
			dop = 14;
		else if (v<99)
			dop = 15;
		else
			dop = 16;
	}
	ipsbuf[IPS_DOP_POS] = (char)('A'+dop);
	data |= GP_GSA;
}

void gpgsv(unsigned char pcnt)
{
	register char *p;
	register unsigned char i;
	register int v;

	if (*param[2]=='1')
		now_sat = 0;
	for (i=4;(now_sat<max_sat) && (i <= pcnt);now_sat++) {
		if (*(p = param[i++]) != '\0')	{ /*PRN*/
			ipsbuf[IPS_SAT_SER_POS+ now_sat*5] = (char)(((v = atoi(p)) < 25) ? v + 'A' -1: v + 'a' - 25);
			if (*(p = param[i++]) != '\0') {/*ELV*/
				v = atoi(p);
				ipsbuf[IPS_SAT_ANG_POS + now_sat*5] /*Elev +##*/
				= (char)((v <90) ? (v+5)/10 + 'A':18-(v+5)/10 + 'a');
			}
			if (*(p = param[i++]) != '\0') { /*adim ###*/
				v = (atoi(p)+5)%360;
				if (v == 10) v = 9;
				if (v == 190) v = 189;
				v /= 10;
				ipsbuf[IPS_SAT_ADI_POS + now_sat*5]
					= (char)((v < 18) ? v+'A': 35-v+'a');
			}
			if (( p = param[i++]) != '\0') {/*level ###*/
				v = atoi(p);
				/* assume all in view type receiver */
				ipsbuf[IPS_SAT_STA_POS+ now_sat*5] = (char) ((v > 0) ? 'F':'D');
				if (v<0) v = 0;
				ipsbuf[IPS_SAT_LVL_POS+ now_sat*5] = (char) (v/2+'A');
			}
		} else
			strncpy(&ipsbuf[IPS_SAT_SER_POS+ now_sat*5],"___AA",5);
	}
	if (*param[1] <= *param[2]) {	/* last gsv sentence ? */
		/* sat < max_sat ?? */
		for (p =&ipsbuf[IPS_SAT_SER_POS + now_sat*5];now_sat<max_sat;now_sat++) {
			*p++ = '_';/* unknown */
			*p++ = '_';/* 0 */
			*p++ = '_';/* 0 */
			*p++ = 'A';/* searching */
			*p++ = 'A';/* signal 0*/
		}
	}
	if (now_sat >= max_sat)
		data |= GP_GSV;
}

void gpgll(void)
{
	register char *p;

	if (timchk(5) != 0) {
		if (*(p = param[1]) != '\0')
			strFcpy(&ipsbuf[IPS_LAT_VAL_POS],p,IPS_LAT_VAL_LEN);	/* copy LAT value without */
		if (*(p = param[2]) != '\0')							/* copy LAT direction */
			ipsbuf[IPS_LAT_DIR_POS]= *p;
		if (*(p = param[3]) != '\0')
			strFcpy(&ipsbuf[IPS_LON_VAL_POS],p,IPS_LON_VAL_LEN);	/* copy LON value without "." */
		if (*(p = param[4]) != '\0')
			ipsbuf[IPS_LON_DIR_POS]= *p;							/* copy LON direction */
		data |= D_POS;
	}
	if (*param[6] == 'A') {/* GPS receiver status */
		strncpy(&ipsbuf[IPS_MES_DATE_POS],&ipsbuf[IPS_UTC_DATE_POS],IPS_TIME_STAMP_LEN);
	} else {
		ipsbuf[IPS_LAT_DIR_POS] |= 0x20;
	}
}

void pgrmm(void)
{
	register char c;

	gpstype = 'G';
	if (strcmp(param[1],"WGS 84") == 0)
		c = 'A';
	else if (strcmp(param[1],"Tokyo") == 0)
		c = 'B';
	else
		c = 'C';	/* Unknown */
	ipsbuf[IPS_DATUM_POS] = c;
}

/* separate parameter from sentence */
unsigned char sep(char *buf)
{
	register char i,*p;

	for(i = -1,p=buf; i <MAXPARAM ;) {
		while(*p == ' ') p++;	/* skip leading blank */
		param[++i] = p;
		if ((p = strchr(p,','))!=NULL) {
			*p++ = '\0';			/* set EOS*/
		} else {
			/*			if (i<0)
							return 0; never */
			if ((p = strchr(param[i],'*'))!=NULL)
				*p = '\0';
			return i;
		}
	}
	return i;
}

/* compare time, copy if changed */
int timchk(int n)
{
	register char *p;

	if (*(p = param[n]) != '\0') {
		if (strncmp(&ipsbuf[IPS_UTC_TIME_POS],p,IPS_UTC_TIME_LEN) < 0) {
			strncpy(&ipsbuf[IPS_UTC_TIME_POS],p,IPS_UTC_TIME_LEN);	/* copy UTC time */
			data |= D_TIME;
			return 1;
		}
	}
	return 0;
}

/* fixed length, skip decimal */

#define FRACLEN 3
#define FRACORD 1000

/* length n, faction 3 */
/* nnnn, nnnn. nnnn.mmmm, .mmmm -> */
/* n=7	####$$$, n=8 #####$$$ */
void strFcpy(char *dist, char *source, unsigned char n)
{
	register unsigned u,d;
	register char *p,*q,*r;

	memset(dist,'0',n);
	p = source;
	while(*p++ >= '0'); /* decimal or comma ? */
	r = p-2;
	q = dist + (n-FRACLEN);
	/* copy int */
	while((q > dist) && (r >= source) )
		*--q = *r--;

	if (*(p-1) == '.') {
		q = dist + (n-FRACLEN);
		if (ipsbuf[IPS_FMT_POS + max_sat*5] < 'A') { /* DMD */
			strncpy(q,p,FRACLEN);			/* copy FRAC */
		} else { /* DMS */
			u = 0;
			d = 1;
			while (*p >= '0') {
				u = u *10 + 6 * (*p++ - '0');
				if ((d *= 10) == FRACORD) {
					u += 5;
					break;
				}
			}
			r = dist + n;
			while ((q < r)&&( u > 0)) {
				*q++ = (char) (u/d + '0');
				u %= d;
				d /= 10;
			}
		}
	}
}

void fillALT(int v)
{
	register char *q;
	register unsigned u, d;

	q = &ipsbuf[IPS_HGH_SGN_POS];
	if (v < 0) {
		u = -v;
		*q++ = '-';
	} else {
		u = v;
		*q++ = '+';
	}
	if (u > 9999) u = 9999;
	for (d=1000;d>0; d /= 10) {
		*q++ = (char)(u/d + '0');
		u %= d;
	}
}

/* atoi with round */
int atoi(const char *p)
{
	register unsigned char u;
	register char sgn;
	register int n = 0;

	sgn = *p;
	if ( sgn == '-' ) {
		*p++;
	} else if (sgn == '+') {
		*p++;
	}
	while ( (u = (unsigned char)(*p++ - '0')) <= 9){
		n *= 10;
		n += u;
	}
	/* round up */
	if (*(p-1) == '.') {
		if ((*p >='5') && (*p <= '9'))
			n++;
	}
	return (sgn == '-') ? -n:n;
}

/* calculate  day of week */
const unsigned char wdmtbl[] = {
	/*	  3 0 3 2 3 2 3 3 2 3 2*/
	6,2,2,5,0,3,5,1,4,6,2,4};

char calwday(unsigned year, unsigned mon, unsigned day)
{
	/* 1<(1901)<=year<=171(2071) */
	if (year<70) year+=100;
	return (char)(((year + (year>>2) + wdmtbl[mon] + day + (((year&3)|(mon&~1)) ? 1:0))%7)+'0');
}

const char RCtbl[][2] = {
	{'5','8'}, /* MENU---MENU------- 00 */
	{'3','3'}, /* -----UP--------- 10 */
	{'5','2'}, /* g---ZOOM-UP---- 20 */
	{'6','0'}, /* E---Up-Right--- 30 */
	{'5','6'}, /* ē---North-UP--- 40 */
	{'3','4'}, /* E-----RIGHT------ 50 */
	{'7','E'}, /* MODE---SELECT----- 60(28) */
	{'5','E'}, /* ---Up-Left---- 70 */
	{'5','3'}, /* POS----POS-------- 80 */
	{'3','2'}, /* -----DOWN------- 90 */
	{'5','1'}, /* k---ZOOM-DOWN-- A0 */
	{'5','D'}, /* E---Down-Right- B0 */
	{'5','7'}, /* ĒT-ON/OFF----- C0 */
	{'3','5'}, /* -----LEFT------- D0 */
	{'5','5'}, /* ---MARK------- E0 */
	{'5','F'}, /* ---Down-Left-- F0 */
	{'5','C'}  /* ENTER--ENTER------100(08) */
};

char *RCCode2str(void)
{
	unsigned char d;

	d = RCCode;
	if (d == 0x28) d = 0x60;
	if (d == 0x08)
		d = 16;
	else
		d >>= 4;
	RCstr[4]=RCtbl[d][0];
	RCstr[5]=RCtbl[d][1];
/*
	d = RCCode >> 4;
	RCstr[0] =	(d <10)? d+'0':d+'A'-10;
	d = RCCode & 0xf;
	RCstr[1] =	(d <10)? d+'0':d+'A'-10;
	RCstr[2] = '\0';
*/
	RCCode = 0xff;
	return(RCstr);
}
